#pragma semicolon 1
#include <sourcemod>
#include <smlib>

#define PLUGIN_VERSION "1.0.5"

new bool:g_bLateLoaded;

new g_iBeamRingSprite = -1;
new g_iRedTrailSprite = -1;

// ConVars
new Handle:g_hCVEnable;
new Handle:g_hCVBotEnable;
new Handle:g_hCVDebug;
new Handle:g_hCVSaveData;
new Handle:g_hCVSteamIDSave;
new Handle:g_hCVSaveInterval;
new Handle:g_hCVPlayerExpire;
new Handle:g_hCVBotMaxlevel;
new Handle:g_hCVAnnounceNewLvl;

new Handle:g_hCVExpNotice;
new Handle:g_hCVExpMax;
new Handle:g_hCVExpStart;
new Handle:g_hCVExpInc;

new Handle:g_hCVExpDamage;
new Handle:g_hCVExpKnifeDmg;
new Handle:g_hCVExpKill;
new Handle:g_hCVExpHeadshot;

new Handle:g_hCVExpTeamwin;
new Handle:g_hCVExpBombPlanted;
new Handle:g_hCVExpBombDefused;
new Handle:g_hCVExpBombExploded;
new Handle:g_hCVExpHostage;
new Handle:g_hCVExpVIPEscaped;

new Handle:g_hCVCreditsInc;
new Handle:g_hCVCreditsStart;
new Handle:g_hCVSalePercent;
new Handle:g_hCVIgnoreLevelBarrier;

new Handle:g_hPlayerAutoSave = INVALID_HANDLE;

#define IF_BOT_ENABLED(%1) if(!IsFakeClient(%1) || (IsFakeClient(%1) && GetConVarBool(g_hCVBotEnable)))
#define IF_BOT_NENABLED(%1) if(!GetConVarBool(g_hCVBotEnable) && IsFakeClient(%1))

#include "cssrpg_items.sp"
#include "cssrpg_database.sp"
#include "cssrpg_players.sp"
#include "cssrpg_stats.sp"
#include "cssrpg_menu.sp"

public Plugin:myinfo = 
{
	name = "CSS:RPG",
	author = "Jannik \"Peace-Maker\" Hartung, SeLfkiLL",
	description = "CSSRPG v1.0.5",
	version = PLUGIN_VERSION,
	url = "http://www.wcfan.de/"
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_bLateLoaded = late;
}

public OnPluginStart()
{
	new Handle:hVersion = CreateConVar("cssrpg_version", PLUGIN_VERSION, "CSS:RPG plugin version", FCVAR_PLUGIN|FCVAR_NOTIFY|FCVAR_REPLICATED|FCVAR_DONTRECORD);
	if(hVersion != INVALID_HANDLE)
	{
		SetConVarString(hVersion, PLUGIN_VERSION);
		HookConVarChange(hVersion, ConVar_VersionChanged);
	}
	
	g_hCVEnable = CreateConVar("cssrpg_enable", "1", "If set to 1, CSSRPG is enabled, if 0, CSSRPG is disabled", 0, true, 0.0, true, 1.0);
	g_hCVBotEnable = CreateConVar("cssrpg_bot_enable", "1", "If set to 1, bots will be able to use the CSSRPG plugin", 0, true, 0.0, true, 1.0);
	g_hCVDebug = CreateConVar("cssrpg_debug", "0", "Turns on debug mode for this plugin", 0, true, 0.0, true, 1.0);
	g_hCVSaveData = CreateConVar("cssrpg_save_data", "1", "If disabled, the database won't be updated (this means player data won't be saved!)", 0, true, 0.0, true, 1.0);
	g_hCVSteamIDSave = CreateConVar("cssrpg_steamid_save", "1", "Save by SteamID instead of by SteamID and name", 0, true, 0.0, true, 1.0);
	g_hCVSaveInterval = CreateConVar("cssrpg_save_interval", "150", "Interval (in seconds) that player data is auto saved (0 = off)", 0, true, 0.0);
	g_hCVPlayerExpire = CreateConVar("cssrpg_player_expire", "30", "Sets how many days until an unused player account is deleted (0 = never)", 0, true, 0.0);
	g_hCVBotMaxlevel = CreateConVar("cssrpg_bot_maxlevel", "250", "The maximum level a bot can reach until its stats are reset (0 = infinite)", 0, true, 0.0);
	g_hCVAnnounceNewLvl = CreateConVar("cssrpg_announce_newlvl", "1", "Global announcement when a player reaches a new level (1 = enable, 0 = disable)", 0, true, 0.0, true, 1.0);
	
	g_hCVExpNotice = CreateConVar("cssrpg_exp_notice", "1", "Sets notifications to players when they gain Experience", 0, true, 0.0, true, 1.0);
	g_hCVExpMax = CreateConVar("cssrpg_exp_max", "50000", "Maximum experience that will ever be required", 0, true, 0.0);
	g_hCVExpStart = CreateConVar("cssrpg_exp_start", "250", "Experience required for Level 1", 0, true, 0.0);
	g_hCVExpInc = CreateConVar("cssrpg_exp_inc", "50", "Incriment experience requied for each level (until cssrpg_exp_max)", 0, true, 0.0);
	
	g_hCVExpDamage = CreateConVar("cssrpg_exp_damage", "1.0", "Experience for hurting an enemy multiplied by the damage done", 0, true, 0.0);
	g_hCVExpKnifeDmg = CreateConVar("cssrpg_exp_knifedmg", "8.0", "Experience for knifing an enemy multiplied by the damage done (must be higher than exp_damage)", 0, true, 0.0);
	g_hCVExpKill = CreateConVar("cssrpg_exp_kill", "15.0", "Experience for a kill multiplied by the victim's level", 0, true, 0.0);
	g_hCVExpHeadshot = CreateConVar("cssrpg_exp_headshot", "50.0", "Experience extra for a headshot", 0, true, 0.0);
	
	g_hCVExpTeamwin = CreateConVar("cssrpg_exp_teamwin", "0.15", "Experience multipled by the experience required and the team ratio given to a team for completing the objective", 0, true, 0.0);
	g_hCVExpBombPlanted = CreateConVar("cssrpg_exp_bombplanted", "0.15", "Experience multipled by the experience required and the team ratio given for planting the bomb", 0, true, 0.0);
	g_hCVExpBombDefused = CreateConVar("cssrpg_exp_bombdefused", "0.30", "Experience multipled by the experience required and the team ratio given for defusing the bomb", 0, true, 0.0);
	g_hCVExpBombExploded = CreateConVar("cssrpg_exp_bombexploded", "0.20", "Experience multipled by the experience required and the team ratio given to the bomb planter when it explodes", 0, true, 0.0);
	g_hCVExpHostage = CreateConVar("cssrpg_exp_hostage", "0.10", "Experience multipled by the experience required and the team ratio for rescuing a hostage", 0, true, 0.0);
	g_hCVExpVIPEscaped = CreateConVar("cssrpg_exp_vipescaped", "0.35", "Experience multipled by the experience required and the team ratio given to the vip when the vip escapes", 0, true, 0.0);
	
	g_hCVCreditsInc = CreateConVar("cssrpg_credits_inc", "5", "Credits given to each new level", 0, true, 0.0);
	g_hCVCreditsStart = CreateConVar("cssrpg_credits_start", "0", "Starting credits for Level 1", 0, true, 0.0);
	g_hCVSalePercent = CreateConVar("cssrpg_sale_percent", "0.75", "Percentage of credits a player gets for selling an item", 0, true, 0.0);
	g_hCVIgnoreLevelBarrier = CreateConVar("cssrpg_ignore_level_barrier", "0", "Ignore the hardcoded maxlevels for the items and allow to set the maxlevel as high as you want.", 0, true, 0.0, true, 1.0);
	
	HookConVarChange(g_hCVEnable, ConVar_EnableChanged);
	HookConVarChange(g_hCVSaveInterval, ConVar_SaveIntervalChanged);
	
	LoadTranslations("common.phrases");
	LoadTranslations("cssrpg.phrases");
	
	RegConsoleCmd("rpgmenu", Cmd_RPGMenu, "Opens the rpg main menu");
	RegConsoleCmd("rpg", Cmd_RPGMenu, "Opens the rpg main menu");
	RegConsoleCmd("rpghelp", Cmd_RPGHelp, "Opens the rpg help menu");
	RegConsoleCmd("rpgrank", Cmd_RPGRank, "Shows your rank or the rank of the target person. rpgrank [name|steamid|#userid]");
	RegConsoleCmd("rpgtop10", Cmd_RPGTop10, "Show the CSS:RPG top 10");
	
	RegAdminCmd("cssrpg_player", Cmd_PlayerInfo, ADMFLAG_ROOT, "Get info about a certain player. Usage cssrpg_player <player name | userid | steamid>", "cssrpg");
	RegAdminCmd("cssrpg_resetstats", Cmd_ResetStats, ADMFLAG_ROOT, "Reset a player's Level, Credits, Experience, and Upgrades (this cannot be undone!). Usage cssrpg_resetstats <player name | userid | steamid>", "cssrpg");
	RegAdminCmd("cssrpg_resetexp", Cmd_ResetExp, ADMFLAG_ROOT, "Reset a player's Experience. Usage cssrpg_resetexp <player name | userid | steamid>", "cssrpg");
	RegAdminCmd("cssrpg_setlvl", Cmd_SetLvl, ADMFLAG_ROOT, "Set a player's Level. Usage cssrpg_setlvl <player name | userid | steamid> <new level>", "cssrpg");
	RegAdminCmd("cssrpg_addlvl", Cmd_AddLvl, ADMFLAG_ROOT, "Add Level(s) to a player's current Level. Usage cssrpg_addlvl <player name | userid | steamid> <levels>", "cssrpg");
	RegAdminCmd("cssrpg_setexp", Cmd_SetExp, ADMFLAG_ROOT, "Set a player's Experience. Usage cssrpg_setexp <player name | userid | steamid> <new exp>", "cssrpg");
	RegAdminCmd("cssrpg_addexp", Cmd_AddExp, ADMFLAG_ROOT, "Give a player Experience. Usage cssrpg_addexp <player name | userid | steamid> <exp>", "cssrpg");
	RegAdminCmd("cssrpg_setcredits", Cmd_SetCredits, ADMFLAG_ROOT, "Set a player's Credits. Usage cssrpg_setcredits <player name | userid | steamid> <new credits>", "cssrpg");
	RegAdminCmd("cssrpg_addcredits", Cmd_AddCredits, ADMFLAG_ROOT, "Add to player's Credits. Usage cssrpg_addcredits <player name | userid | steamid> <credits>", "cssrpg");
	RegAdminCmd("cssrpg_setupgradelvl", Cmd_SetUpgradeLvl, ADMFLAG_ROOT, "Set a player's Upgrade Level. Usage cssrpg_setupgradelvl <player name | userid | steamid> <upgrade> <level|max>", "cssrpg");
	RegAdminCmd("cssrpg_giveupgrade", Cmd_GiveUpgrade, ADMFLAG_ROOT, "Give a player an Upgrade (increment). Usage cssrpg_giveupgrade <player name | userid | steamid> <upgrade>", "cssrpg");
	RegAdminCmd("cssrpg_giveall", Cmd_GiveAll, ADMFLAG_ROOT, "Give a player all the Upgrades available. Usage cssrpg_giveall <player name | userid | steamid>", "cssrpg");
	RegAdminCmd("cssrpg_takeupgrade", Cmd_TakeUpgrade, ADMFLAG_ROOT, "Take an Upgrade from a player (decrement). Usage cssrpg_takeupgrade <player name | userid | steamid> <upgrade>", "cssrpg");
	RegAdminCmd("cssrpg_buyupgrade", Cmd_BuyUpgrade, ADMFLAG_ROOT, "Force a player to buy an Upgrade. Usage cssrpg_buyupgrade <player name | userid | steamid> <upgrade>", "cssrpg");
	RegAdminCmd("cssrpg_sellupgrade", Cmd_SellUpgrade, ADMFLAG_ROOT, "Force a player to sell an Upgrade (full refund). Usage cssrpg_sellupgrade <player name | userid | steamid> <upgrade>", "cssrpg");
	RegAdminCmd("cssrpg_sellall", Cmd_SellAll, ADMFLAG_ROOT, "Force a player to sell all their Upgrades (full refund). Usage cssrpg_sellall <player name | userid | steamid>", "cssrpg");
	RegAdminCmd("cssrpg_db_delplayer", Cmd_DBDelPlayer, ADMFLAG_ROOT, "Delete a player entry from both tables in the database (this cannot be undone!). Usage: cssrpg_db_delplayer <full name | player db id | steamid>", "cssrpg");
	RegAdminCmd("cssrpg_db_mass_sell", Cmd_DBMassSell, ADMFLAG_ROOT, "Force everyone in the database (and playing) to sell a specific upgrade. Usage: cssrpg_db_mass_sell <upgrade>", "cssrpg");
	RegAdminCmd("cssrpg_db_write", Cmd_DBWrite, ADMFLAG_ROOT, "Write current player data to the database", "cssrpg");
	
	RegAdminCmd("cssrpg_debug_playerlist", Cmd_DebugPlayerlist, ADMFLAG_ROOT, "List all RPG players", "cssrpg");
	
	HookEvent("player_footstep", Event_OnPlayerFootstep);
	HookEvent("player_hurt", Event_OnPlayerHurt);
	HookEvent("player_jump", Event_OnPlayerJump);
	HookEvent("item_pickup", Event_OnItemPickup);
	HookEvent("hegrenade_detonate", Event_OnGrenadeDetonate);
	HookEvent("flashbang_detonate", Event_OnGrenadeDetonate);
	HookEvent("smokegrenade_detonate", Event_OnGrenadeDetonate);
	HookEvent("player_spawn", Event_OnPlayerSpawn);
	HookEvent("player_death", Event_OnPlayerDeath);
	HookEvent("player_say", Event_OnPlayerSay);
	HookEvent("round_start", Event_OnRoundStart);
	HookEvent("round_end", Event_OnRoundEnd);
	HookEvent("bomb_planted", Event_OnBombPlanted);
	HookEvent("bomb_defused", Event_OnBombDefused);
	HookEvent("bomb_exploded", Event_OnBombExploded);
	HookEvent("hostage_rescued", Event_OnHostageRescued);
	HookEvent("vip_escaped", Event_OnVIPEscaped);
	HookEvent("player_team", Event_OnPlayerTeam);
	
	RegisterItems();
	InitDatabase();
	
	InitMenu();
	
	if(g_bLateLoaded)
	{
		decl String:sAuth[40];
		for(new i=1;i<=MaxClients;i++)
		{
			if(!IsClientInGame(i))
				continue;
			
			OnClientPutInServer(i);
			
			if(IsClientAuthorized(i) && GetClientAuthString(i, sAuth, sizeof(sAuth)))
			{
				OnClientAuthorized(i, sAuth);
			}
		}
	}
}

public ConVar_VersionChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	SetConVarString(convar, PLUGIN_VERSION);
}

public ConVar_SaveIntervalChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	ClearHandle(g_hPlayerAutoSave);
	g_hPlayerAutoSave = CreateTimer(GetConVarFloat(g_hCVSaveInterval), Timer_SavePlayers, _, TIMER_REPEAT);
}

public ConVar_EnableChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if(GetConVarBool(convar) || !GetConVarBool(g_hCVSaveData))
		return;
	
	UnhookConVarChange(convar, ConVar_EnableChanged);
	SetConVarBool(convar, true);
	SaveAllPlayers();
	SetConVarBool(convar, false);
	HookConVarChange(convar, ConVar_EnableChanged);
	PrintToServer("CSS:RPG cssrpg_enable: CSS:RPG data has been saved");
}

public OnConfigsExecuted()
{
	ClearHandle(g_hPlayerAutoSave);
	g_hPlayerAutoSave = CreateTimer(GetConVarFloat(g_hCVSaveInterval), Timer_SavePlayers, _, TIMER_REPEAT);
}

public OnMapStart()
{
	PrecacheSound("buttons/button14.wav", true);
	PrecacheSound("buttons/blip2.wav", true);
	PrecacheSound("physics/glass/glass_impact_bullet1.wav", true);
	PrecacheSound("physics/glass/glass_impact_bullet2.wav", true);
	PrecacheSound("physics/glass/glass_impact_bullet3.wav", true);
	PrecacheSound("physics/glass/glass_sheet_impact_hard1.wav", true);
	PrecacheSound("physics/glass/glass_sheet_impact_hard2.wav", true);
	PrecacheSound("physics/glass/glass_sheet_impact_hard3.wav", true);
	PrecacheSound("physics/surfaces/tile_impact_bullet1.wav", true);
	PrecacheSound("physics/surfaces/tile_impact_bullet2.wav", true);
	PrecacheSound("physics/surfaces/tile_impact_bullet3.wav", true);
	PrecacheSound("physics/surfaces/tile_impact_bullet4.wav", true);
	PrecacheSound("weapons/physcannon/physcannon_charge.wav", true);
	PrecacheSound("npc/overwatch/cityvoice/fprison_missionfailurereminder.wav", true);
	
	g_iBeamRingSprite = PrecacheModel("sprites/lgtning.vmt", true);
	g_iRedTrailSprite = PrecacheModel("sprites/combineball_trail_red_1.vmt", true);
	
	// Initialize items
	InitItems();
	
	DatabaseMaid();
}

public OnMapEnd()
{
	ShutdownItems();
	SaveAllPlayers();
}

public OnClientAuthorized(client, const String:auth[])
{
	InitPlayer(client);
	AddPlayer(client, auth);
}

public OnClientPutInServer(client)
{
	Denial_OnClientPutInServer(client);
	
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	PrintToChat(client, "\x01This server is running CSS:RPG v%s (\x04http://cssrpg.sf.net\x01).", PLUGIN_VERSION);
	PrintToChat(client, "%t", "greeting");
}

public OnClientDisconnect(client)
{
	FPistol_ResetClient(client);
	IceStab_ResetClient(client);
	Impulse_ResetClient(client);
	LJump_ResetClient(client);
	Denial_ResetClient(client);
	SaveData(client);
	ClearPlayerRankCache(client);
}

public OnGameFrame()
{
	IceStab_OnGameFrame();
	LJump_OnGameFrame();
}

public Action:Cmd_RPGMenu(client, args)
{
	if(!client)
	{
		ReplyToCommand(client, "CSS:RPG: This command is ingame only.");
		return Plugin_Handled;
	}
	
	DisplayMainMenu(client);
	
	return Plugin_Handled;
}

public Action:Cmd_RPGHelp(client, args)
{
	if(!client)
	{
		ReplyToCommand(client, "CSS:RPG: This command is ingame only.");
		return Plugin_Handled;
	}
	
	DisplayHelpMenu(client);
	
	return Plugin_Handled;
}

public Action:Cmd_RPGRank(client, args)
{
	if(!client)
	{
		ReplyToCommand(client, "CSS:RPG: This command is ingame only.");
		return Plugin_Handled;
	}
	
	decl String:sText[256];
	GetCmdArgString(sText, sizeof(sText));
	TrimString(sText);
	
	if(!sText[0])
	{
		PrintRankToChat(client, -1);
	}
	else
	{
		new iTarget = FindTarget(client, sText, true, false);
		if(iTarget == -1)
			return Plugin_Handled;
		PrintRankToChat(iTarget, -1);
	}
	
	return Plugin_Handled;
}

public Action:Cmd_RPGTop10(client, args)
{
	if(!client)
	{
		ReplyToCommand(client, "CSS:RPG: This command is ingame only.");
		return Plugin_Handled;
	}
	
	DisplayTop10Menu(client);
	
	return Plugin_Handled;
}

//////////////
// Admin Commands
//////////////
public Action:Cmd_PlayerInfo(client, args)
{
	decl String:sText[256];
	GetCmdArgString(sText, sizeof(sText));
	TrimString(sText);
	new iTarget = FindTarget(client, sText, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	ReplyToCommand(client, "CSS:RPG: ----------");
	ReplyToCommand(client, "CSS:RPG %N: ", iTarget);
	
	decl String:sSteamID[32];
	GetClientAuthString(iTarget, sSteamID, sizeof(sSteamID));
	ReplyToCommand(client, "CSS:RPG Info: Index: %d, UserID: %d, SteamID: %s, Database ID: %d:%d", iTarget, GetClientUserId(iTarget), sSteamID, g_iPlayerDBId[iTarget], g_iPlayerDBItemID[iTarget]);
	
	ReplyToCommand(client, "CSS:RPG Stats: Level: %d, Experience: %d/%d, Credits: %d, Rank: %d/%d", GetPlayerLevel(iTarget), GetPlayerExperience(iTarget), Stats_LvlToExp(GetPlayerLevel(iTarget)), GetPlayerCredits(iTarget), GetPlayerRank(iTarget), GetRankCount());
	
	ReplyToCommand(client, "CSS:RPG Upgrades: ");
	new Handle:hItems = GetItemsList();
	new iNumItems = GetArraySize(hItems);
	decl Handle:hItem, String:sName[64];
	for(new i=0;i<iNumItems;i++)
	{
		hItem = GetArrayCell(hItems, i);
		GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
		ReplyToCommand(client, "CSS:RPG -: %s Level %d", sName, GetPlayerItemLevel(iTarget, i));
	}
	ReplyToCommand(client, "CSS:RPG: ----------");
	
	return Plugin_Handled;
}

public Action:Cmd_ResetStats(client, args)
{
	decl String:sText[256];
	GetCmdArgString(sText, sizeof(sText));
	TrimString(sText);
	new iTarget = FindTarget(client, sText, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	ResetStats(iTarget);
	
	ReplyToCommand(client, "CSS:RPG resetstats: %N's stats have been permanently reset", iTarget);
	
	return Plugin_Handled;
}

public Action:Cmd_ResetExp(client, args)
{
	decl String:sText[256];
	GetCmdArgString(sText, sizeof(sText));
	TrimString(sText);
	new iTarget = FindTarget(client, sText, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	SetPlayerExperience(iTarget, 0);
	
	ReplyToCommand(client, "CSS:RPG resetexp: %N's Experience has been reset", iTarget);
	
	return Plugin_Handled;
}

public Action:Cmd_SetLvl(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_setlvl <player name | userid | steamid> <new level>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sLevel[16];
	GetCmdArg(2, sLevel, sizeof(sLevel));
	new iLevel = StringToInt(sLevel);
	
	if(iLevel < 1)
	{
		ReplyToCommand(client, "CSS:RPG: Minimum level is 1!");
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerLevel(iTarget);
	
	// Do a proper level up
	if(iLevel > iOldLevel)
	{
		Stats_PlayerNewLevel(iTarget, iLevel-iOldLevel);
	}
	// Decrease level manually, don't touch the credits/items
	else
	{
		SetPlayerLevel(iTarget, iLevel);
		SetPlayerExperience(iTarget, 0);
		
		if(GetConVarBool(g_hCVAnnounceNewLvl))
			PrintToChatAll("%t", "new_lvl1", iTarget, GetPlayerLevel(iTarget));
	}
	
	ReplyToCommand(client, "CSS:RPG setlvl: %N has been set to Level %d (previously Level %d)", iTarget, iLevel, iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_AddLvl(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_addlvl <player name | userid | steamid> <levels>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sLevel[16];
	GetCmdArg(2, sLevel, sizeof(sLevel));
	new iLevelIncrease = StringToInt(sLevel);
	
	if(iLevelIncrease < 1)
	{
		ReplyToCommand(client, "CSS:RPG: You have to add at least 1 level!");
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerLevel(iTarget);
	
	Stats_PlayerNewLevel(iTarget, iLevelIncrease);
	
	ReplyToCommand(client, "CSS:RPG addlvl: %N has been set to Level %d (previously Level %d)", iTarget, GetPlayerLevel(iTarget), iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_SetExp(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_setexp <player name | userid | steamid> <new exp>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sExperience[16];
	GetCmdArg(2, sExperience, sizeof(sExperience));
	new iExperience = StringToInt(sExperience);
	
	if(iExperience < 0)
	{
		ReplyToCommand(client, "CSS:RPG: Experience must be >= 0!");
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerLevel(iTarget);
	new iOldExperience = GetPlayerExperience(iTarget);
	
	if(iExperience > iOldExperience)
		Stats_AddExperience(iTarget, iExperience-iOldExperience, false);
	else
		SetPlayerExperience(iTarget, iExperience);
	
	ReplyToCommand(client, "CSS:RPG setexp: %N is now Level %d and has %d/%d Experience (previously Level %d with %d/%d Experience)", iTarget, GetPlayerLevel(iTarget), GetPlayerExperience(iTarget), Stats_LvlToExp(GetPlayerLevel(iTarget)), iOldLevel, iOldExperience, Stats_LvlToExp(iOldLevel));
	
	return Plugin_Handled;
}

public Action:Cmd_AddExp(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_addexp <player name | userid | steamid> <exp>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sExperienceIncrease[16];
	GetCmdArg(2, sExperienceIncrease, sizeof(sExperienceIncrease));
	new iExperienceIncrease = StringToInt(sExperienceIncrease);
	
	if(iExperienceIncrease < 1)
	{
		ReplyToCommand(client, "CSS:RPG: You have to add at least 1 experience!");
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerLevel(iTarget);
	new iOldExperience = GetPlayerExperience(iTarget);
	
	Stats_AddExperience(iTarget, iExperienceIncrease, false);
	
	ReplyToCommand(client, "CSS:RPG setexp: %N is now Level %d and has %d/%d Experience (previously Level %d with %d/%d Experience)", iTarget, GetPlayerLevel(iTarget), GetPlayerExperience(iTarget), Stats_LvlToExp(GetPlayerLevel(iTarget)), iOldLevel, iOldExperience, Stats_LvlToExp(iOldLevel));
	
	return Plugin_Handled;
}

public Action:Cmd_SetCredits(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_setcredits <player name | userid | steamid> <new credits>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sCredits[16];
	GetCmdArg(2, sCredits, sizeof(sCredits));
	new iCredits = StringToInt(sCredits);
	
	if(iCredits < 0)
	{
		ReplyToCommand(client, "CSS:RPG: Credits must be >= 0!");
		return Plugin_Handled;
	}
	
	new iOldCredits = GetPlayerCredits(iTarget);
	
	SetPlayerCredits(iTarget, iCredits);
	
	ReplyToCommand(client, "CSS:RPG setcredits: %N now has %d Credits (previously had %d Credits)", iTarget, iCredits, iOldCredits);
	
	return Plugin_Handled;
}

public Action:Cmd_AddCredits(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_addcredits <player name | userid | steamid> <credits>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sCredits[16];
	GetCmdArg(2, sCredits, sizeof(sCredits));
	new iCredits = StringToInt(sCredits);
	
	if(iCredits < 1)
	{
		ReplyToCommand(client, "CSS:RPG: You have to add at least 1 credit!");
		return Plugin_Handled;
	}
	
	new iOldCredits = GetPlayerCredits(iTarget);
	
	SetPlayerCredits(iTarget, iOldCredits+iCredits);
	
	ReplyToCommand(client, "CSS:RPG addcredits: %N now has %d Credits (previously had %d Credits)", iTarget, iCredits, iOldCredits);
	
	return Plugin_Handled;
}

public Action:Cmd_SetUpgradeLvl(client, args)
{
	if(GetCmdArgs() < 3)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_setupgradelvl <player name | userid | steamid> <upgrade> <level|max>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sItem[16];
	GetCmdArg(2, sItem, sizeof(sItem));
	TrimString(sItem);
	StripQuotes(sItem);
	new iIndex = GetItemIndexByShortname(sItem);
	new Handle:hItem = GetItemByIndex(iIndex);
	if(iIndex == -1)
	{
		ReplyToCommand(client, "CSS:RPG: There is no upgrade with name \"%s\".", sItem);
		return Plugin_Handled;
	}
	
	decl String:sLevel[16];
	GetCmdArg(3, sLevel, sizeof(sLevel));
	StripQuotes(sLevel);
	
	new iLevel;
	if(StrEqual(sLevel, "max", false) || iLevel > GetArrayCell(hItem, ITEM_MAXLEVEL))
		iLevel = GetArrayCell(hItem, ITEM_MAXLEVEL);
	else
		iLevel = StringToInt(sLevel);
	
	if(iLevel < 0)
	{
		ReplyToCommand(client, "CSS:RPG: Item levels start at 0!");
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerItemLevel(iTarget, iIndex);
	
	// Item level increased
	if(iOldLevel < iLevel)
	{
		while(GetPlayerItemLevel(iTarget, iIndex) < iLevel)
		{
			if(!GiveItem(iTarget, iIndex))
				break;
		}
	}
	// Item level decreased..
	else
	{
		while(GetPlayerItemLevel(iTarget, iIndex) > iLevel)
		{
			if(!TakeItem(iTarget, iIndex))
				break;
		}
	}
	
	decl String:sName[64];
	GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
	
	ReplyToCommand(client, "CSS:RPG setupgradelvl: %N now has %s Level %d (previously Level %d)", iTarget, sName, GetPlayerItemLevel(iTarget, iIndex), iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_GiveUpgrade(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_giveupgrade <player name | userid | steamid> <upgrade>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sItem[16];
	GetCmdArg(2, sItem, sizeof(sItem));
	TrimString(sItem);
	StripQuotes(sItem);
	new iIndex = GetItemIndexByShortname(sItem);
	new Handle:hItem = GetItemByIndex(iIndex);
	if(iIndex == -1)
	{
		ReplyToCommand(client, "CSS:RPG: There is no upgrade with name \"%s\".", sItem);
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerItemLevel(iTarget, iIndex);
	
	decl String:sName[64];
	GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
	
	if(iOldLevel >= GetArrayCell(hItem, ITEM_MAXLEVEL))
	{
		ReplyToCommand(client, "CSS:RPG giveupgrade: %N has the maximum Level for %s (Level %d)", iTarget, sName, iOldLevel);
		return Plugin_Handled;
	}
	
	if(!GiveItem(iTarget, iIndex))
	{
		ReplyToCommand(client, "CSS:RPG giveupgrade: Item refused to upgrade.");
		return Plugin_Handled;
	}
	
	ReplyToCommand(client, "CSS:RPG giveupgrade: %N now has %s Level %d (previously Level %d)", iTarget, sName, GetPlayerItemLevel(iTarget, iIndex), iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_GiveAll(client, args)
{
	if(GetCmdArgs() < 1)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_giveall <player name | userid | steamid>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	new Handle:hItems = GetItemsList();
	new iNumItems = GetArraySize(hItems);
	new Handle:hItem;
	for(new i=0;i<iNumItems;i++)
	{
		hItem = GetArrayCell(hItems, i);
		if(!GetArrayCell(hItem, ITEM_ENABLE))
			continue;
		
		SetPlayerItemLevel(iTarget, i, GetArrayCell(hItem, ITEM_MAXLEVEL));
	}
	
	ReplyToCommand(client, "CSS:RPG giveall: %N now has all Upgrades", iTarget);
	
	return Plugin_Handled;
}

public Action:Cmd_TakeUpgrade(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_takeupgrade <player name | userid | steamid> <upgrade>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sItem[16];
	GetCmdArg(2, sItem, sizeof(sItem));
	TrimString(sItem);
	StripQuotes(sItem);
	new iIndex = GetItemIndexByShortname(sItem);
	new Handle:hItem = GetItemByIndex(iIndex);
	if(iIndex == -1)
	{
		ReplyToCommand(client, "CSS:RPG: There is no upgrade with name \"%s\".", sItem);
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerItemLevel(iTarget, iIndex);
	
	decl String:sName[64];
	GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
	
	if(iOldLevel <= 0)
	{
		ReplyToCommand(client, "CSS:RPG takeupgrade: %N doesn't have %s", iTarget, sName);
		return Plugin_Handled;
	}
	
	if(!TakeItem(iTarget, iIndex))
	{
		ReplyToCommand(client, "CSS:RPG takeupgrade: Item refused to downgrade.");
		return Plugin_Handled;
	}
	
	ReplyToCommand(client, "CSS:RPG takeupgrade: %N now has %s Level %d (previously Level %d)", iTarget, sName, GetPlayerItemLevel(iTarget, iIndex), iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_BuyUpgrade(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_buyupgrade <player name | userid | steamid> <upgrade>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sItem[16];
	GetCmdArg(2, sItem, sizeof(sItem));
	TrimString(sItem);
	StripQuotes(sItem);
	new iIndex = GetItemIndexByShortname(sItem);
	new Handle:hItem = GetItemByIndex(iIndex);
	if(iIndex == -1)
	{
		ReplyToCommand(client, "CSS:RPG: There is no upgrade with name \"%s\".", sItem);
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerItemLevel(iTarget, iIndex);
	
	decl String:sName[64];
	GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
	
	if(iOldLevel >= GetArrayCell(hItem, ITEM_MAXLEVEL))
	{
		ReplyToCommand(client, "CSS:RPG buyupgrade: %N has the maximum Level for %s (Level %d)", iTarget, sName, iOldLevel);
		return Plugin_Handled;
	}
	
	new iCost = GetItemCost(iIndex, iOldLevel);
	if(iCost > GetPlayerCredits(iTarget))
	{
		ReplyToCommand(client, "CSS:RPG buyupgrade: %N doesn't have enough credits to purchase %s (%d/%d)", iTarget, sName, GetPlayerCredits(iTarget), iCost);
		return Plugin_Handled;
	}
	
	if(!BuyItem(iTarget, iIndex))
	{
		ReplyToCommand(client, "CSS:RPG buyupgrade: Item refused to upgrade.");
		return Plugin_Handled;
	}
	
	ReplyToCommand(client, "CSS:RPG buyupgrade: %N now has %s Level %d (previously Level %d)", iTarget, sName, GetPlayerItemLevel(iTarget, iIndex), iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_SellUpgrade(client, args)
{
	if(GetCmdArgs() < 2)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_sellupgrade <player name | userid | steamid> <upgrade>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	decl String:sItem[16];
	GetCmdArg(2, sItem, sizeof(sItem));
	TrimString(sItem);
	StripQuotes(sItem);
	new iIndex = GetItemIndexByShortname(sItem);
	new Handle:hItem = GetItemByIndex(iIndex);
	if(iIndex == -1)
	{
		ReplyToCommand(client, "CSS:RPG: There is no upgrade with name \"%s\".", sItem);
		return Plugin_Handled;
	}
	
	new iOldLevel = GetPlayerItemLevel(iTarget, iIndex);
	
	decl String:sName[64];
	GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
	
	if(iOldLevel <= 0)
	{
		ReplyToCommand(client, "CSS:RPG sellupgrade: %N doesn't have %s", iTarget, sName);
		return Plugin_Handled;
	}
	
	if(!TakeItem(iTarget, iIndex))
	{
		ReplyToCommand(client, "CSS:RPG sellupgrade: Item refused to downgrade.");
		return Plugin_Handled;
	}
	
	// Full refund!
	SetPlayerCredits(iTarget, GetPlayerCredits(iTarget) + GetItemCost(iIndex, iOldLevel));
	
	ReplyToCommand(client, "CSS:RPG sellupgrade: %N now has %s Level %d (previously Level %d)", iTarget, sName, GetPlayerItemLevel(iTarget, iIndex), iOldLevel);
	
	return Plugin_Handled;
}

public Action:Cmd_SellAll(client, args)
{
	if(GetCmdArgs() < 1)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_sellall <player name | userid | steamid>");
		return Plugin_Handled;
	}
	
	decl String:sPlayer[64];
	GetCmdArg(1, sPlayer, sizeof(sPlayer));
	TrimString(sPlayer);
	new iTarget = FindTarget(client, sPlayer, false, false);
	if(iTarget == -1)
		return Plugin_Handled;
	
	new Handle:hItems = GetItemsList();
	new iNumItems = GetArraySize(hItems);
	new Handle:hItem;
	for(new i=0;i<iNumItems;i++)
	{
		hItem = GetArrayCell(hItems, i);
		if(!GetArrayCell(hItem, ITEM_ENABLE))
			continue;
		
		while(GetPlayerItemLevel(iTarget, i) > 0)
		{
			TakeItem(iTarget, i);
			SetPlayerCredits(iTarget, GetPlayerCredits(iTarget) + GetItemCost(i, GetPlayerItemLevel(iTarget, i)));
		}
	}
	
	ReplyToCommand(client, "CSS:RPG sellall: %N has sold all Upgrades and has %ld Credits", iTarget, GetPlayerCredits(iTarget));
	
	return Plugin_Handled;
}

public Action:Cmd_DBDelPlayer(client, args)
{
	if(GetCmdArgs() < 1)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_db_delplayer <full name | player db id | steamid>");
		return Plugin_Handled;
	}
	
	decl String:sTarget[64];
	GetCmdArgString(sTarget, sizeof(sTarget));
	TrimString(sTarget);
	StripQuotes(sTarget);
	
	decl String:sQuery[128], iPlayerID;
	// Match as steamid
	if(IsValidSteamID(sTarget))
	{
		new iTarget = FindClientBySteamID(sTarget);
		if(iTarget != -1)
			RemovePlayer(iTarget);
		
		Format(sQuery, sizeof(sQuery), "SELECT items_id, name FROM %s WHERE steamid = '%s'", TBL_PLAYERS, sTarget);
		SQL_TQuery(g_hDatabase, SQL_CheckDeletePlayer, sQuery, client);
	}
	// Match as playerid
	else if(StringToIntEx(sTarget, iPlayerID) && iPlayerID > 0)
	{
		new iTarget = GetClientByPlayerID(iPlayerID);
		if(iTarget != -1)
			RemovePlayer(iTarget);
		
		Format(sQuery, sizeof(sQuery), "SELECT items_id, name FROM %s WHERE player_id = '%d'", TBL_PLAYERS, iPlayerID);
		SQL_TQuery(g_hDatabase, SQL_CheckDeletePlayer, sQuery, client);
	}
	// Match as name
	else
	{
		new iTarget = FindClientByExactName(sTarget);
		if(iTarget != -1)
			RemovePlayer(iTarget);
		
		Format(sQuery, sizeof(sQuery), "SELECT items_id, name FROM %s WHERE name = '%s'", TBL_PLAYERS, sTarget);
		SQL_TQuery(g_hDatabase, SQL_CheckDeletePlayer, sQuery, client);
	}
	return Plugin_Handled;
}

public Action:Cmd_DBMassSell(client, args)
{
	if(GetCmdArgs() < 1)
	{
		ReplyToCommand(client, "CSS:RPG: Usage: cssrpg_db_mass_sell <upgrade>");
		return Plugin_Handled;
	}
	
	decl String:sItem[16];
	GetCmdArg(1, sItem, sizeof(sItem));
	TrimString(sItem);
	StripQuotes(sItem);
	new iIndex = GetItemIndexByShortname(sItem);
	new Handle:hItem = GetItemByIndex(iIndex);
	if(iIndex == -1)
	{
		ReplyToCommand(client, "CSS:RPG: There is no upgrade with name \"%s\".", sItem);
		return Plugin_Handled;
	}
	
	// Handle players ingame
	new iOldLevel;
	for(new i=1;i<=MaxClients;i++)
	{
		if(!IsClientInGame(i))
			continue;
		
		iOldLevel = GetPlayerItemLevel(i, iIndex);
		if(iOldLevel <= 0)
			continue;
		
		while(iOldLevel > 0)
		{
			TakeItem(i, iIndex);
			SetPlayerCredits(i, GetPlayerCredits(i) + GetItemCost(iIndex, iOldLevel--));
		}
	}
	
	decl String:sShortName[64];
	GetArrayString(hItem, ITEM_SHORTNAME, sShortName, sizeof(sShortName));
	
	// Update all other players in the database
	new Handle:hData = CreateDataPack();
	WritePackCell(hData, client);
	WritePackCell(hData, _:hItem);
	WritePackCell(hData, iIndex);
	
	decl String:sQuery[128];
	Format(sQuery, sizeof(sQuery), "SELECT items_id, %s FROM %s WHERE %s > '0'", sShortName, TBL_ITEMS, sShortName);
	SQL_TQuery(g_hDatabase, SQL_MassDeleteItem, sQuery, hData);
	
	return Plugin_Handled;
}

public Action:Cmd_DebugPlayerlist(client, args)
{
	for(new i=1;i<=MaxClients;i++)
	{
		if(!IsClientInGame(i))
			continue;
		
		ReplyToCommand(client, "Player: %s, UserID: %d, Level: %d, Experience: %d/%d", i, GetClientUserId(i), GetPlayerLevel(i), GetPlayerExperience(i), Stats_LvlToExp(GetPlayerLevel(i)));
	}
}

public Action:Cmd_DBWrite(client, args)
{
	SaveAllPlayers();
	ReplyToCommand(client, "CSS:RPG db_write: All player data has been saved to the database");
	return Plugin_Handled;
}

public Event_OnPlayerFootstep(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	LJump_OnPlayerFootstep(client);
}

public Event_OnPlayerJump(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	LJump_OnPlayerJump(client);
}

public Event_OnItemPickup(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	decl String:sItem[32];
	GetEventString(event, "item", sItem, sizeof(sItem));
	Denial_OnItemPickup(client, sItem);
}

public Event_OnGrenadeDetonate(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	decl String:sWeapon[32];
	GetEventName(event, sWeapon, sizeof(sWeapon));
	Denial_OnGrenadeDetonate(client, sWeapon);
}

public Event_OnPlayerHurt(Handle:event, const String:error[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	
	new dmg_health = GetEventInt(event, "dmg_health");
	new dmg_armor = GetEventInt(event, "dmg_armor");
	decl String:sWeapon[32];
	GetEventString(event, "weapon", sWeapon, sizeof(sWeapon));
	
	if(attacker == 0 || victim == 0)
		return;
	
	IceStab_LimitDamage(victim, dmg_health, sWeapon);
	
	Stats_PlayerDamage(attacker, victim, sWeapon, dmg_health, dmg_armor);
	Vampire_PlayerDamage(attacker, victim, dmg_health, dmg_armor);
	if(StrContains(sWeapon, "hegrenade", false) != -1)
	{
		FNade_PlayerDamage(attacker, victim, dmg_health, dmg_armor);
	}
	else if(StrContains(sWeapon, "knife", false) != -1)
	{
		IceStab_PlayerDamage(attacker, victim, dmg_health, dmg_armor);
	}
	else
	{
		FPistol_PlayerDamage(attacker, victim, sWeapon);
		Impulse_PlayerDamage(attacker, victim);
	}
}

public Event_OnPlayerSpawn(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	HealthP_SetSpawnHealth(client);
	Stealth_SetVisibilities();
	FPistol_ResetClient(client);
	IceStab_ResetClient(client);
	LJump_ResetClient(client);
	Denial_OnPlayerSpawn(client);
}

public Event_OnPlayerDeath(Handle:event, const String:error[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if(attacker == 0 || victim == 0)
		return;
	
	Stats_PlayerKill(attacker, victim, GetEventBool(event, "headshot"));
	FPistol_ResetClient(victim);
	IceStab_ResetClient(victim);
	LJump_ResetClient(victim);
	Denial_OnPlayerDeath(victim);
}

public Event_OnPlayerSay(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	decl String:sText[256];
	GetEventString(event, "text", sText, sizeof(sText));
	
	if(StrEqual(sText, "rpgmenu") || StrEqual(sText, "rpg"))
		DisplayMainMenu(client);
	else if(StrEqual(sText, "rpghelp"))
		DisplayHelpMenu(client);
	else if(StrContains(sText, "rpgrank") == 0)
	{
		TrimString(sText);
		if(!sText[7])
		{
			PrintRankToChat(client, -1);
		}
		else
		{
			new iTarget = FindTarget(client, sText[7], true, false);
			if(iTarget == -1)
				return;
			PrintRankToChat(iTarget, -1);
		}
	}
	else if(StrEqual(sText, "rpgtop10"))
		DisplayTop10Menu(client);
	else if(StrEqual(sText, "rpggaben"))
		EmitSoundToClient(client, "npc/overwatch/cityvoice/fprison_missionfailurereminder.wav");
}

public Event_OnRoundStart(Handle:event, const String:error[], bool:dontBroadcast)
{
	Impulse_OnRoundStart();
}

public Event_OnRoundEnd(Handle:event, const String:error[], bool:dontBroadcast)
{
	Stats_WinningTeam(GetEventInt(event, "winner"), GetEventInt(event, "reason"));
}

public Event_OnBombPlanted(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(!client)
		return;
	
	Stats_BombPlanted(client);
}

public Event_OnBombDefused(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(!client)
		return;
	
	Stats_BombDefused(client);
}

public Event_OnBombExploded(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(!client)
		return;
	
	Stats_BombExploded(client);
}

public Event_OnHostageRescued(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(!client)
		return;
	
	Stats_HostageRescued(client);
}

public Event_OnVIPEscaped(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(!client)
		return;
	
	Stats_VIPEscaped(client);
}

public Event_OnPlayerTeam(Handle:event, const String:error[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(!client)
		return;
	
	if(GetConVarBool(g_hCVEnable) && GetPlayerLevel(client) <= 1 && GetEventInt(event, "oldteam") <= 1)
		ShowMOTDPanel(client, "CSS:RPG Disclaimer", "http://cssrpg.sourceforge.net/help/disclaimer.html", MOTDPANEL_TYPE_URL);
	
	Denial_ResetItems(client);
}

public Action:Timer_SavePlayers(Handle:timer, any:data)
{
	if(!GetConVarBool(g_hCVEnable) || !GetConVarBool(g_hCVSaveData) || !GetConVarBool(g_hCVSaveInterval))
		return Plugin_Continue;
	
	SaveAllPlayers();
	
	return Plugin_Continue;
}

public SQL_CheckDeletePlayer(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE || strlen(error) > 0)
	{
		LogError("While trying to find player for deletion (%s)", error);
		return;
	}
	
	if(!SQL_GetRowCount(hndl))
	{
		if(client == 0 || IsClientInGame(client))
			ReplyToCommand(client, "CSS:RPG db_delplayer: Unable to find the specified player in the database.");
		return;
	}
	
	new iItemID = SQL_FetchInt(hndl, 0);
	if(GetConVarBool(g_hCVSaveData))
	{
		decl String:sQuery[128];
		Format(sQuery, sizeof(sQuery), "DELETE FROM %s WHERE items_id = '%d'", TBL_ITEMS, iItemID);
		SQL_TQuery(g_hDatabase, SQL_DoNothing, sQuery);
		Format(sQuery, sizeof(sQuery), "DELETE FROM %s WHERE items_id = '%d'", TBL_PLAYERS, iItemID);
		SQL_TQuery(g_hDatabase, SQL_DoNothing, sQuery);
	}
	else
	{
		if(client == 0 || IsClientInGame(client))
		{
			ReplyToCommand(client, "CSS:RPG db_delplayer: Notice: cssrpg_save_data is set to '0', command had no effect.");
			ReplyToCommand(client, "CSS:RPG db_delplayer: Ignore the proceeding message.");
		}
	}
	
	decl String:sName[64];
	SQL_FetchString(hndl, 1, sName, sizeof(sName));
	if(client == 0 || IsClientInGame(client))
		ReplyToCommand(client, "CSS:RPG db_delplayer: Player '%s' has been deleted from the database.", sName);
}

public SQL_MassDeleteItem(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE || strlen(error) > 0)
	{
		LogError("Error during mass deletion of item (%s)", error);
		return;
	}
	
	ResetPack(data);
	new client = ReadPackCell(data);
	new Handle:hItem = Handle:ReadPackCell(data);
	new iIndex = ReadPackCell(data);
	CloseHandle(data);
	
	decl String:sName[64], String:sShortName[16];
	GetArrayString(hItem, ITEM_NAME, sName, sizeof(sName));
	GetArrayString(hItem, ITEM_SHORTNAME, sShortName, sizeof(sShortName));
	
	if(SQL_GetRowCount(hndl) == 0)
	{
		if(client == 0 || IsClientInGame(client))
			ReplyToCommand(client, "CSS:RPG db_mass_sell: Nobody has the Upgrade '%s' purchased at any level.", sName);
		return;
	}
	
	if(GetConVarBool(g_hCVSaveData))
	{
		new iOldLevel, iAddCredits, iItemsID;
		decl String:sQuery[128];
		while(SQL_MoreRows(hndl))
		{
			SQL_FetchRow(hndl);
			
			iItemsID = SQL_FetchInt(hndl, 1);
			
			iOldLevel = SQL_FetchInt(hndl, 2);
			if(iOldLevel < 0)
			{
				DebugMsg("Negative level for upgrade %s in database at itemid %d!", sName, iItemsID);
				iOldLevel = 0;
			}
			if(iOldLevel > GetArrayCell(hItem, ITEM_MAXLEVEL))
			{
				DebugMsg("Upgrade level higher than max level of upgrade %s at itemid %d!", sName, iItemsID);
				iOldLevel = GetArrayCell(hItem, ITEM_MAXLEVEL);
			}
			
			iAddCredits = 0;
			while(iOldLevel)
				iAddCredits += GetItemCost(iIndex, iOldLevel--);
			
			Format(sQuery, sizeof(sQuery), "UPDATE %s SET %s = '0' WHERE items_id = '%d'", TBL_ITEMS, sShortName, iItemsID);
			SQL_TQuery(g_hDatabase, SQL_DoNothing, sQuery);
			Format(sQuery, sizeof(sQuery), "UPDATE %s SET credits = (credits + %d) WHERE items_id = '%d'", TBL_ITEMS, iAddCredits, iItemsID);
			SQL_TQuery(g_hDatabase, SQL_DoNothing, sQuery);
		}
	}
	else
	{
		if(client == 0 || IsClientInGame(client))
			ReplyToCommand(client, "CSS:RPG db_mass_sell: Notice: cssrpg_save_data is set to '0', command had no effect");
	}
	
	if(client == 0 || IsClientInGame(client))
		ReplyToCommand(client, "CSS:RPG db_mass_sell: All (%d) players in the database with Upgrade '%s' have been refunded their credits", SQL_GetRowCount(hndl), sName);
}

stock DebugMsg(String:format[], any:...)
{
	if(!GetConVarBool(g_hCVDebug))
		return;
	
	decl String:sBuffer[192];
	SetGlobalTransTarget(LANG_SERVER);
	VFormat(sBuffer, sizeof(sBuffer), format, 2);
	PrintToServer(sBuffer);
}

/*stock SetCheats(bool:enable)
{
	static Handle:sv_cheats = INVALID_HANDLE;
	static bool:already_set = false;
	
	if(sv_cheats == INVALID_HANDLE)
		sv_cheats = FindConVar("sv_cheats");
	
	if(enable)
	{
		already_set = GetConVarBool(sv_cheats);
		new iOldFlags = GetConVarFlags(sv_cheats);
		SetConVarFlags(sv_cheats, iOldFlags&~FCVAR_NOTIFY);
		SetConVarBool(sv_cheats, true);
		SetConVarFlags(sv_cheats, iOldFlags);
	}
	else
	{
		if(!already_set)
		{
			new iOldFlags = GetConVarFlags(sv_cheats);
			SetConVarFlags(sv_cheats, iOldFlags&~FCVAR_NOTIFY);
			SetConVarBool(sv_cheats, false);
			SetConVarFlags(sv_cheats, iOldFlags);
		}
	}
}*/

stock bool:IsValidSteamID(String:sSteamID[])
{
	if(strlen(sSteamID) < 10)
		return false;
	
	if(StrContains(sSteamID, "STEAM_") != 0)
		return false;
	
	new iOffset = 6, bool:bSHITSOURCEPAWN = true;
	for(new repeats=0;repeats<3;repeats++)
	{
		while(bSHITSOURCEPAWN)
		{
			if(!sSteamID[iOffset])
			{
				if(repeats != 2)
					return false;
				else
					break;
			}
			else if(IsCharNumeric(sSteamID[iOffset]))
			{
				iOffset++;
				continue;
			}
			else if(sSteamID[iOffset] == ':')
			{
				iOffset++;
				break;
			}
			else
			{
				return false;
			}
		}
	}
	return true;
}

stock FindClientBySteamID(String:sSteamID[])
{
	decl String:sTemp[MAX_NAME_LENGTH];
	for(new i=1;i<=MaxClients;i++)
	{
		if(IsClientInGame(i) && IsClientAuthorized(i))
		{
			GetClientAuthString(i, sTemp, sizeof(sTemp));
			if(StrEqual(sSteamID, sTemp))
				return i;
		}
	}
	return -1;
}

stock FindClientByExactName(String:sName[])
{
	decl String:sTemp[MAX_NAME_LENGTH];
	for(new i=1;i<=MaxClients;i++)
	{
		if(IsClientInGame(i))
		{
			GetClientName(i, sTemp, sizeof(sTemp));
			if(StrEqual(sName, sTemp))
				return i;
		}
	}
	return -1;
}

/**
 * GiveAmmo gives ammo of a certain type to a player - duh.
 *
 * @param client        The client index.
 * @param ammo            Amount of bullets to give. Is capped at weapon's limit.
 * @param ammotype        Type of ammo to give to player.
 * @param suppressSound Don't play the ammo pickup sound.
 * 
 * @return Amount of bullets actually given. -1 on error.
 */
stock GiveAmmo(client, ammo, ammotype, bool:bSuppressSound)
{
	static Handle:hGiveAmmo = INVALID_HANDLE;
	static bool:bErroaaarrd = false;
	
	if(hGiveAmmo == INVALID_HANDLE)
	{
		new Handle:hGameConf = LoadGameConfigFile("cssrpg.games");
		if(hGameConf == INVALID_HANDLE)
		{
			if(!bErroaaarrd)
				LogError("Can't find cssrpg.games.txt gamedata. Ammo Resupply won't obey weapon ammo limits!");
			bErroaaarrd = true;
			return -1;
		}
		
		StartPrepSDKCall(SDKCall_Player);
		if(!PrepSDKCall_SetFromConf(hGameConf, SDKConf_Virtual, "GiveAmmo"))
		{
			CloseHandle(hGameConf);
			if(!bErroaaarrd)
				LogError("Can't find CBaseCombatCharacter::GiveAmmo(int, int, bool) offset. Ammo Resupply won't obey weapon ammo limits!");
			bErroaaarrd = true;
			return -1;
		}
		PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_Plain);
		PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_Plain);
		PrepSDKCall_AddParameter(SDKType_Bool, SDKPass_Plain);
		PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
		hGiveAmmo = EndPrepSDKCall();

		CloseHandle(hGameConf);
		
		if(hGiveAmmo == INVALID_HANDLE)
		{
			if(!bErroaaarrd)
				LogError("Failed to finish GiveAmmo SDKCall. Ammo Resupply won't obey weapon ammo limits!");
			bErroaaarrd = true;
			return -1;
		}
	}
	
	return SDKCall(hGiveAmmo, client, ammo, ammotype, bSuppressSound);
}