#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

new g_iCachedRank[MAXPLAYERS+1] = {-1,...};
new g_iCachedRankCount = 0;

/* Calculate the experience needed for this level */
stock Stats_LvlToExp(iLevel)
{
	new iExp;
	
	if(iLevel <= 1)
		iExp = GetConVarInt(g_hCVExpStart);
	else
		iExp = iLevel * GetConVarInt(g_hCVExpInc) + GetConVarInt(g_hCVExpStart);
	
	return iExp > GetConVarInt(g_hCVExpMax) ? GetConVarInt(g_hCVExpMax) : iExp;
}

/* Calculate how many levels to increase by current level and experience */
stock Stats_CalcLvlInc(iLevel, iExp)
{
	new iLevelIncrease, iExpRequired;
	
	new bool:bFUCKSOURCEPAWN = true;
	while(bFUCKSOURCEPAWN)
	{
		iExpRequired = Stats_LvlToExp(iLevel);
		if(iExp > iExpRequired)
		{
			iLevelIncrease++;
			iExp -= iExpRequired;
			continue;
		}
		else if(iExp == iExpRequired)
		{
			iLevelIncrease++;
		}
		break;
	}
	
	return iLevelIncrease;
}

stock Float:Stats_TeamRatio(iTeam)
{
	if(iTeam <= 1)
		return 0.0;
	
	new Float:fTeamRatio;
	
	if(iTeam == 2)
		fTeamRatio = float(GetTeamClientCount(2)) / float(GetTeamClientCount(3));
	else
		fTeamRatio = float(GetTeamClientCount(3)) / float(GetTeamClientCount(2));
	return fTeamRatio;
}

stock Stats_PlayerNewLevel(client, iLevelIncrease)
{
	if(IsFakeClient(client) && GetConVarBool(g_hCVBotMaxlevel))
	{
		if((GetPlayerLevel(client) + iLevelIncrease) > GetConVarInt(g_hCVBotMaxlevel))
		{
			DebugMsg("Bot %N has surpassed the maximum level of %d, resetting its stats", client, GetConVarInt(g_hCVBotMaxlevel));
			ResetStats(client);
			return;
		}
	}
	
	SetPlayerLevel(client, GetPlayerLevel(client)+iLevelIncrease);
	SetPlayerExperience(client, 0);
	SetPlayerCredits(client, GetPlayerCredits(client) + iLevelIncrease * GetConVarInt(g_hCVCreditsInc));
	
	DebugMsg("%N is now level %d (%d level increase(s))", client, GetPlayerLevel(client), iLevelIncrease);
	
	if(GetConVarBool(g_hCVAnnounceNewLvl))
		PrintToChatAll("%t", "new_lvl1", client, GetPlayerLevel(client));
	
	if(!IsFakeClient(client))
	{
		EmitSoundToClient(client, "buttons/blip2.wav");
		if((GetPlayerLevel(client) - iLevelIncrease) <= 1)
		{
			/* for newbies */
			PrintToChat(client, "%t", "newbie_lvl1");
			PrintToChat(client, "%t", "newbie_lvl2");
		}
		else
		{
			PrintToChat(client, "%t", "new_lvl2", GetPlayerCredits(client));
		}
	}
	else
	{
		BotPickUpgrade(client);
	}
}

stock Stats_AddExperience(client, iExperience, bool:bHideNotice)
{
	IF_BOT_NENABLED(client)
		return;
	
	SetPlayerExperience(client, GetPlayerExperience(client) + iExperience);
	
	new iExpRequired = Stats_LvlToExp(GetPlayerLevel(client));
	
	if(!bHideNotice && GetConVarBool(g_hCVExpNotice))
		PrintHintText(client, "%t", "exp_hint", iExperience, GetPlayerExperience(client), iExpRequired);
	
	if(GetPlayerExperience(client) >= iExpRequired)
		Stats_PlayerNewLevel(client, Stats_CalcLvlInc(GetPlayerLevel(client), GetPlayerExperience(client)));
}

stock Stats_PlayerDamage(attacker, victim, String:sWeapon[], iDmgHealth, iDmgArmor)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	// Ignore teamattack
	if(GetClientTeam(attacker) == GetClientTeam(victim))
		return;
	
	new iExp;
	new iTotalDmg = iDmgHealth+iDmgArmor;
	if(StrContains(sWeapon, "knife") != -1)
	{
		if(GetConVarFloat(g_hCVExpKnifeDmg) > GetConVarFloat(g_hCVExpDamage))
			iExp = RoundToCeil(float(iTotalDmg) * GetConVarFloat(g_hCVExpKnifeDmg));
		else
			iExp = RoundToCeil(float(iTotalDmg) * GetConVarFloat(g_hCVExpDamage));
	}
	else
	{
		iExp = RoundToCeil(float(iTotalDmg) * GetConVarFloat(g_hCVExpDamage));
	}
	
	Stats_AddExperience(attacker, iExp, true);
}

stock Stats_PlayerKill(attacker, victim, bool:bHeadshot)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	// Ignore teamattack
	if(GetClientTeam(attacker) == GetClientTeam(victim))
		return;
	
	new iExp = GetPlayerLevel(victim) * GetConVarInt(g_hCVExpKill);
	if(bHeadshot)
		iExp += GetConVarInt(g_hCVExpHeadshot);
	
	Stats_AddExperience(attacker, iExp, false);
}

stock Stats_BombPlanted(client)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	new iTeam = GetClientTeam(client);
	if(iTeam <= 1)
		return;
	
	new Float:fTeamRatio = Stats_TeamRatio(iTeam == 2 ? 3 : 2);
	Stats_AddExperience(client, RoundToCeil(float(Stats_LvlToExp(GetPlayerLevel(client))) * GetConVarInt(g_hCVExpBombPlanted) * fTeamRatio), false);
}

stock Stats_BombDefused(client)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	new iTeam = GetClientTeam(client);
	if(iTeam <= 1)
		return;
	
	new Float:fTeamRatio = Stats_TeamRatio(iTeam == 2 ? 3 : 2);
	Stats_AddExperience(client, RoundToCeil(float(Stats_LvlToExp(GetPlayerLevel(client))) * GetConVarInt(g_hCVExpBombDefused) * fTeamRatio), false);
}

stock Stats_BombExploded(client)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	new iTeam = GetClientTeam(client);
	if(iTeam <= 1)
		return;
	
	new Float:fTeamRatio = Stats_TeamRatio(iTeam == 2 ? 3 : 2);
	Stats_AddExperience(client, RoundToCeil(float(Stats_LvlToExp(GetPlayerLevel(client))) * GetConVarInt(g_hCVExpBombExploded) * fTeamRatio), false);
}

stock Stats_HostageRescued(client)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	new iTeam = GetClientTeam(client);
	if(iTeam <= 1)
		return;
	
	new Float:fTeamRatio = Stats_TeamRatio(iTeam == 2 ? 3 : 2);
	Stats_AddExperience(client, RoundToCeil(float(Stats_LvlToExp(GetPlayerLevel(client))) * GetConVarInt(g_hCVExpHostage) * fTeamRatio), false);
}

stock Stats_VIPEscaped(client)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	new iTeam = GetClientTeam(client);
	if(iTeam <= 1)
		return;
	
	new Float:fTeamRatio = Stats_TeamRatio(iTeam == 2 ? 3 : 2);
	Stats_AddExperience(client, RoundToCeil(float(Stats_LvlToExp(GetPlayerLevel(client))) * GetConVarInt(g_hCVExpVIPEscaped) * fTeamRatio), false);
}

/* Experience given to the team for one of these reasons:
	1   Target Successfully Bombed!
	2   The VIP has escaped!
	3   VIP has been assassinated!
	7   The bomb has been defused!
	11   All Hostages have been rescued!
	12   Target has been saved!
	13   Hostages have not been rescued!
*/
stock Stats_WinningTeam(iTeam, iReason)
{
	if(!GetConVarBool(g_hCVEnable))
		return;
	
	switch(iReason)
	{
		case 1, 2, 3, 7, 11, 12, 13:
		{
		}
		default:
			return;
	}
	
	new Float:fTeamRatio;
	if(iTeam == 2)
		fTeamRatio = Stats_TeamRatio(3);
	else if(iTeam == 3)
		fTeamRatio = Stats_TeamRatio(2);
	else
		return;
	
	for(new i=1;i<=MaxClients;i++)
	{
		if(IsClientInGame(i) && GetClientTeam(i) == iTeam)
			Stats_AddExperience(i, RoundToCeil(float(Stats_LvlToExp(GetPlayerLevel(i))) * GetConVarFloat(g_hCVExpTeamwin) * fTeamRatio), false);
	}
}


/*	//////////////////////////////////////
	CRPG_RankManager
	////////////////////////////////////// */

stock UpdatePlayerRank(client)
{
	decl String:sQuery[128];
	Format(sQuery, sizeof(sQuery), "SELECT COUNT(*) FROM %s WHERE level > '%d' OR (level == '%d' AND exp > '%d')", TBL_PLAYERS, GetPlayerLevel(client), GetPlayerLevel(client), GetPlayerExperience(client));
	SQL_TQuery(g_hDatabase, SQL_GetPlayerRank, sQuery, GetClientUserId(client));
}

stock GetPlayerRank(client)
{
	UpdatePlayerRank(client);
	return g_iCachedRank[client];
}

stock ClearPlayerRankCache(client)
{
	g_iCachedRank[client] = -1;
}

public SQL_GetPlayerRank(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	new client = GetClientOfUserId(userid);
	if(!client)
		return;
	
	if(hndl == INVALID_HANDLE || strlen(error) > 0)
	{
		LogError("Unable to get player rank (%s)", error);
		return;
	}
	
	SQL_FetchRow(hndl);
	
	g_iCachedRank[client] = SQL_FetchInt(hndl, 0) + 1; // +1 since the query returns the count, not the rank
}

stock UpdateRankCount()
{
	decl String:sQuery[128];
	Format(sQuery, sizeof(sQuery), "SELECT COUNT(*) FROM %s", TBL_PLAYERS);
	SQL_TQuery(g_hDatabase, SQL_GetRankCount, sQuery);
}

stock GetRankCount()
{
	UpdateRankCount();
	
	if(g_iCachedRankCount > 0)
		return g_iCachedRankCount;
	
	return 0;
}

public SQL_GetRankCount(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE || strlen(error) > 0)
	{
		LogError("Unable to get player rank (%s)", error);
		return;
	}
	
	SQL_FetchRow(hndl);
	
	g_iCachedRankCount = SQL_FetchInt(hndl, 0);
	
	for(new i=1;i<=MaxClients;i++)
	{
		if(IsClientInGame(i) && !IsFakeClient(i) && g_iPlayerDBId[i] < 0)
			g_iCachedRankCount++; /* accounts for players not saved in the db */
	}
}

stock PrintRankToChat(client, sendto)
{
	if(sendto == -1)
		PrintToChatAll("%t", "rpgrank", client, GetPlayerLevel(client), GetPlayerRank(client), GetRankCount(), GetPlayerExperience(client), Stats_LvlToExp(GetPlayerLevel(client)), GetPlayerCredits(client));
	else
		PrintToChat(sendto, "%t", "rpgrank", client, GetPlayerLevel(client), GetPlayerRank(client), GetRankCount(), GetPlayerExperience(client), Stats_LvlToExp(GetPlayerLevel(client)), GetPlayerCredits(client));
}

stock DisplayTop10Menu(client)
{
	decl String:sQuery[128];
	Format(sQuery, sizeof(sQuery), "SELECT name, level, exp, credits FROM %s ORDER BY level DESC, exp DESC LIMIT 10", TBL_PLAYERS);
	SQL_TQuery(g_hDatabase, SQL_GetTop10, sQuery, GetClientUserId(client));
}

public SQL_GetTop10(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	new client = GetClientOfUserId(userid);
	if(!client)
		return;
	
	if(hndl == INVALID_HANDLE || strlen(error) > 0)
	{
		LogError("Unable to get player top10 (%s)", error);
		return;
	}
	
	decl String:sBuffer[128];
	Format(sBuffer, sizeof(sBuffer), "%T\n-----\n", "top10_title", client);
	
	new Handle:hPanel = CreatePanel();
	SetPanelTitle(hPanel, sBuffer);
	
	new iIndex = 1;
	while(SQL_MoreRows(hndl))
	{
		if(!SQL_FetchRow(hndl))
			continue;
		
		SQL_FetchString(hndl, 0, sBuffer, sizeof(sBuffer));
		Format(sBuffer, sizeof(sBuffer), "-->%d. %s Lvl: %d Exp: %d Cr: %d", iIndex++, sBuffer, SQL_FetchInt(hndl, 1), SQL_FetchInt(hndl, 2), SQL_FetchInt(hndl, 3));
		DrawPanelText(hPanel, sBuffer);
	}
	
	SetPanelKeys(hPanel, 255);
	
	SendPanelToClient(hPanel, client, Panel_HandleTop10, MENU_TIME_FOREVER);
	CloseHandle(hPanel);
}

public Panel_HandleTop10(Handle:menu, MenuAction:action, param1, param2)
{
}