#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

#define FPISTOL_GLOCK	0.45
#define FPISTOL_USP		0.45
#define FPISTOL_P228	0.3
#define FPISTOL_DEAGLE	0.50
#define FPISTOL_ELITE	0.8
#define FPISTOL_FSEVEN	0.3

#define FPISTOL_INC 0.1 /* FrostPistol speed time increase for each level */

new Handle:g_hFPistolConfig;

new Float:g_fFPistolLastSpeed[MAXPLAYERS+1];
new Handle:g_hFPistolResetSpeed[MAXPLAYERS+1] = {INVALID_HANDLE,...};

Item_FPistol_PreInit()
{
	g_hFPistolConfig = RegisterItemType("FrostPistol", "fpistol", 10, true, 10, 20, 15, FPistol_Buy, FPistol_Sell);
}

public bool:FPistol_Buy(client)
{
	return true;
}

public bool:FPistol_Sell(client)
{
	return true;
}

FPistol_ResetClient(client)
{
	if(g_hFPistolResetSpeed[client] != INVALID_HANDLE && IsClientInGame(client))
		TriggerTimer(g_hFPistolResetSpeed[client]);
	ClearHandle(g_hFPistolResetSpeed[client]);
}

FPistol_PlayerDamage(attacker, victim, String:weapon[])
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hFPistolConfig, ITEM_ENABLE))
		return;
	
	IF_BOT_NENABLED(attacker)
		return;
	
	if(GetClientTeam(attacker) == GetClientTeam(victim))
		return;
	
	new iLevel = GetPlayerItemLevel(attacker, GetArrayCell(g_hFPistolConfig, ITEM_INDEX));
	
	if(iLevel <= 0)
		return;
	
	new Float:fSpeed;
	if(StrContains(weapon, "glock", false) != -1)
		fSpeed = FPISTOL_GLOCK;
	else if(StrContains(weapon, "usp", false) != -1)
		fSpeed = FPISTOL_USP;
	else if(StrContains(weapon, "p228", false) != -1)
		fSpeed = FPISTOL_P228;
	else if(StrContains(weapon, "deagle", false) != -1)
		fSpeed = FPISTOL_DEAGLE;
	else if(StrContains(weapon, "elite", false) != -1)
		fSpeed = FPISTOL_ELITE;
	else if(StrContains(weapon, "fiveseven", false) != -1)
		fSpeed = FPISTOL_FSEVEN;
	else
		return;
	
	// Don't have impulse going wonky
	Impulse_StopEffect(victim);
	
	if(g_hFPistolResetSpeed[victim] == INVALID_HANDLE)
	{
		g_fFPistolLastSpeed[victim] = fSpeed;
		SetEntPropFloat(victim, Prop_Send, "m_flLaggedMovementValue", fSpeed);
	}
	else
	{
		if(g_fFPistolLastSpeed[victim] > fSpeed)
		{
			g_fFPistolLastSpeed[victim] = fSpeed;
			SetEntPropFloat(victim, Prop_Send, "m_flLaggedMovementValue", fSpeed);
		}
	}
	
	decl String:sSound[PLATFORM_MAX_PATH];
	Format(sSound, sizeof(sSound), "physics/surfaces/tile_impact_bullet%d.wav", GetRandomInt(1, 4));
	EmitSoundToAll(sSound, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 0.8, SNDPITCH_NORMAL, victim);
	
	ClearHandle(g_hFPistolResetSpeed[victim]);
	g_hFPistolResetSpeed[victim] = CreateTimer(float(iLevel)*FPISTOL_INC, FPistol_Timer_ResetSpeed, GetClientUserId(victim), TIMER_FLAG_NO_MAPCHANGE);
}

public Action:FPistol_Timer_ResetSpeed(Handle:timer, any:userid)
{
	new client = GetClientOfUserId(userid);
	if(!client)
		return Plugin_Stop;
	
	SetEntPropFloat(client, Prop_Send, "m_flLaggedMovementValue", 1.0);
	
	g_hFPistolResetSpeed[client] = INVALID_HANDLE;
	return Plugin_Stop;
}

stock bool:IsFrozenByFrostPistol(client)
{
	return g_hFPistolResetSpeed[client] != INVALID_HANDLE;
}