#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

/* Percent of player's jump to increase */
#define LJUMP_INC 0.20

new Handle:g_hLJumpConfig;

new Float:g_fLJumpPreviousVelocity[MAXPLAYERS+1][3];
new bool:g_bLJumpPlayerJumped[MAXPLAYERS+1];

Item_LJump_PreInit()
{
	g_hLJumpConfig = RegisterItemType("LongJump", "ljump", 10, true, 5, 20, 15, LJump_Buy, LJump_Sell);
}

public bool:LJump_Buy(client)
{
	return true;
}

public bool:LJump_Sell(client)
{
	return true;
}

LJump_ResetClient(client)
{
	g_bLJumpPlayerJumped[client] = false;
}

LJump_OnPlayerJump(client)
{
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", g_fLJumpPreviousVelocity[client]);
	g_bLJumpPlayerJumped[client] = true;
}

LJump_OnPlayerFootstep(client)
{
	g_bLJumpPlayerJumped[client] = false; /* Player tried to sneak out some jump juice! */
}

LJump_OnGameFrame()
{
	decl Float:vVelocity[3];
	for(new i=1;i<=MaxClients;i++)
	{
		if(!IsClientInGame(i))
			continue;
		
		if(!g_bLJumpPlayerJumped[i])
			continue;
		
		GetEntPropVector(i, Prop_Data, "m_vecVelocity", vVelocity);
		if(vVelocity[2] > g_fLJumpPreviousVelocity[i][2])
		{
			LJump_HasJumped(i, vVelocity);
			g_bLJumpPlayerJumped[i] = false;
		}
	}
}

LJump_HasJumped(client, Float:vVelocity[3])
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hLJumpConfig, ITEM_ENABLE))
		return;
	
	IF_BOT_NENABLED(client)
		return;
	
	new iLevel = GetPlayerItemLevel(client, GetArrayCell(g_hLJumpConfig, ITEM_INDEX));
	
	if(iLevel <= 0)
		return;
	
	new Float:fIncrease = LJUMP_INC * float(iLevel) + 1.0;
	vVelocity[0] *= fIncrease;
	vVelocity[1] *= fIncrease;
	
	TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vVelocity);
}