#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

#define STEALTH_INC 40

new Handle:g_hStealthConfig;

new Handle:g_hStealthTimer = INVALID_HANDLE;

Item_Stealth_PreInit()
{
	g_hStealthConfig = RegisterItemType("Stealth", "stealth", 5, true, 5, 15, 10, Stealth_Buy, Stealth_Sell);
}

Stealth_Init()
{
	//if(!GetArrayCell(g_hStealthConfig, ITEM_ENABLE))
	//	return;
	
	g_hStealthTimer = CreateTimer(10.0, Stealth_Timer_SetVisibilities, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

Stealth_Shutdown()
{
	ClearHandle(g_hStealthTimer);
}

public bool:Stealth_Buy(client)
{
	SetEntityRenderMode(client, RENDER_TRANSCOLOR);
	Entity_SetRenderColor(client, -1, -1, -1, 255 - GetPlayerItemLevel(client, GetArrayCell(g_hStealthConfig, ITEM_INDEX)) * STEALTH_INC);
	return true;
}

public bool:Stealth_Sell(client)
{
	SetEntityRenderMode(client, RENDER_TRANSCOLOR);
	Entity_SetRenderColor(client, -1, -1, -1, 255 - GetPlayerItemLevel(client, GetArrayCell(g_hStealthConfig, ITEM_INDEX)) * STEALTH_INC);
	return true;
}

public Action:Stealth_Timer_SetVisibilities(Handle:timer, any:data)
{
	Stealth_SetVisibilities();
	
	return Plugin_Continue;
}

stock Stealth_SetVisibilities()
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hStealthConfig, ITEM_ENABLE))
		return;
	
	new bool:bBotEnable = GetConVarBool(g_hCVBotEnable);
	
	decl iStealthLevel;
	for(new i=1;i<=MaxClients;i++)
	{
		if(!IsClientInGame(i))
			continue;
		
		if(!bBotEnable && IsFakeClient(i))
			continue;
		
		iStealthLevel = GetPlayerItemLevel(i, GetArrayCell(g_hStealthConfig, ITEM_INDEX));
		if(iStealthLevel <= 0)
			continue;
		
		SetEntityRenderMode(i, RENDER_TRANSCOLOR);
		Entity_SetRenderColor(i, -1, -1, -1, 255 - iStealthLevel * STEALTH_INC);
	}
}